<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="优惠券名称" prop="couponName">
        <el-input
          v-model="queryParams.couponName"
          placeholder="请输入优惠券名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="优惠券面值" prop="couponPrice">
        <el-input
          v-model="queryParams.couponPrice"
          placeholder="请输入优惠券面值"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="优惠券类型" prop="couponType">
        <el-select   v-model="queryParams.couponType" placeholder="请选择优惠券类型" clearable size="small" >
         <el-option
                v-for="item in couponTypeOptions"
                :key="item.dictValue"
                :label="item.dictLabel"
                :value="item.dictValue"
              />
        </el-select>
      </el-form-item>
      <el-form-item label="发布时间">
            <el-date-picker v-model="dateRange" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期"></el-date-picker>
        </el-form-item>
      <el-form-item>
        <el-button type="cyan" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          size="mini"
          @click="handleRefresh"
        >刷新</el-button>
      </el-col>
    </el-row>

    <el-table  height="500" border v-loading="loading" :data="storeCouponIssueList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="ID" align="center" prop="id" />
      <el-table-column label="优惠券" align="center" prop="couponName" />
      <el-table-column label="优惠券领取开始时间" align="center" prop="startTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.startTime, '{y}-{m}-{d} {h}时') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="优惠券领取结束时间" align="center" prop="limitTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.limitTime, '{y}-{m}-{d} {h}时') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="优惠券面值" align="center" prop="couponPrice" />
      <el-table-column label="最低消费" align="center" prop="useMinPrice" />
      <el-table-column label="优惠券有效期限(天)" align="center" prop="couponTime" />
      <el-table-column label="总数量" align="center" prop="totalCount" />
      <el-table-column label="待领取数量" align="center" prop="remainCount" />
      <el-table-column label="类型" align="center" prop="couponType" >
          <template slot-scope="scope">
              <el-tag prop="couponType" v-for="(item, index) in couponTypeOptions"    v-if="scope.row.couponType==item.dictValue">{{item.dictLabel}}</el-tag>
          </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="status" >
          <template slot-scope="scope">
              <el-tag prop="status" v-for="(item, index) in statusOptions"    v-if="scope.row.status==item.dictValue">{{item.dictLabel}}</el-tag>
          </template>
      </el-table-column>
      <el-table-column label="发布时间" align="center" prop="createTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['store:storeCouponIssue:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['store:storeCouponIssue:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改优惠券领取对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
         <el-form-item label="状态">
            <el-radio-group v-model="form.status">
              <el-radio :label="item.dictValue" v-for="item in statusOptions" >{{item.dictLabel}}</el-radio>
            </el-radio-group>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listStoreCouponIssue, getStoreCouponIssue, delStoreCouponIssue, addStoreCouponIssue, updateStoreCouponIssue, exportStoreCouponIssue } from "@/api/live/liveCouponIssue";

export default {
  name: "StoreCouponIssue",
  data() {
    return {
      couponTypeOptions:[],
      statusOptions:[],
      dateRange:[],
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 优惠券领取表格数据
      storeCouponIssueList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        couponName: null,
        couponId: null,
        couponType: null,
        startTime: null,
        endTime: null,
        totalCount: null,
        remainCount: null,
        isPermanent: null,
        status: null,
        isDel: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        isPermanent: [
          { required: true, message: "是否无限张数不能为空", trigger: "blur" }
        ],
        status: [
          { required: true, message: "1 正常 0 未开启 -1 已无效不能为空", trigger: "blur" }
        ],
        isDel: [
          { required: true, message: "1 正常 0 未开启 -1 已无效不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
     this.getDicts("common_status").then((response) => {
      this.statusOptions = response.data;
    });
     this.getDicts("store_coupon_type").then((response) => {
      this.couponTypeOptions = response.data;
    });
    this.getList();
  },
  methods: {
    handleRefresh(){
      this.getList();
    },
    /** 查询优惠券领取列表 */
    getList() {
      this.loading = true;
      if (this.dateRange!=null && this.dateRange.length>0){
        this.dateRange[0]=this.dateRange[0]+" 00:00:00"
        this.dateRange[1]=this.dateRange[1]+" 23:59:59"
      }
      listStoreCouponIssue(this.addDateRange(this.queryParams, this.dateRange)).then(response => {
        this.storeCouponIssueList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        couponName: null,
        couponId: null,
        couponType: null,
        startTime: null,
        endTime: null,
        totalCount: null,
        remainCount: null,
        isPermanent: null,
        status: 0,
        isDel: null,
        createTime: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.dateRange = []; // 清空日期范围选择器的值
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加优惠券领取";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getStoreCouponIssue(id).then(response => {
        this.form = response.data;
        this.form.status = response.data.status.toString();
        this.open = true;
        this.title = "修改优惠券领取";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateStoreCouponIssue(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addStoreCouponIssue(this.form).then(response => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除优惠券领取编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delStoreCouponIssue(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(function() {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有优惠券领取数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportStoreCouponIssue(queryParams);
        }).then(response => {
          this.download(response.msg);
        }).catch(function() {});
    }
  }
};
</script>
